// CLOckTimer.cpp : implementation file
//

#include "stdafx.h"
#include "ModemDial.h"
#include "CLOckTimer.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCLOckTimer dialog


CCLOckTimer::CCLOckTimer(CWnd* pParent /*=NULL*/)
	: CDialog(CCLOckTimer::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCLOckTimer)
	m_edmstart = _T("");
	m_edmstop = _T("");
	m_vmanual = _T("");
	m_edminterval = 0.0;
	m_edtime1 = _T("");
	//}}AFX_DATA_INIT
}


void CCLOckTimer::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCLOckTimer)
	DDX_Control(pDX, IDC_STATICCLOCK, m_icon);
	DDX_Control(pDX, IDC_STOP, m_bstop);
	DDX_Control(pDX, IDC_START, m_bstart);
	DDX_Text(pDX, IDC_EDMSTART, m_edmstart);
	DDX_Text(pDX, IDC_EDMSTOP, m_edmstop);
	DDX_Text(pDX, IDC_VMANUAL, m_vmanual);
	DDX_Text(pDX, IDC_EDMINTERVAL, m_edminterval);
	DDX_Text(pDX, IDC_EDTIME2, m_edtime1);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCLOckTimer, CDialog)
	//{{AFX_MSG_MAP(CCLOckTimer)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_START, OnStart)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCLOckTimer message handlers

BOOL CCLOckTimer::OnInitDialog() 
{
	CDialog::OnInitDialog();

	CMenu* pSysMenu = GetSystemMenu(FALSE);

	pSysMenu->RemoveMenu(SC_SIZE, MF_BYCOMMAND);
	pSysMenu->RemoveMenu(SC_MAXIMIZE, MF_BYCOMMAND);

	SetLocalTime(&systime);

	m_hIcon1 = AfxGetApp()->LoadIcon(IDI_CLOCK1);
	m_hIcon2 = AfxGetApp()->LoadIcon(IDI_CLOCK2);
	m_hIcon3 = AfxGetApp()->LoadIcon(IDI_CLOCK3);
	m_hIcon4 = AfxGetApp()->LoadIcon(IDI_CLOCK4);
	m_hIcon5 = AfxGetApp()->LoadIcon(IDI_CLOCK5);
	m_hIcon6 = AfxGetApp()->LoadIcon(IDI_CLOCK6);

	m_uTimerID = SetTimer(IDD_CLOCKTIMER,1,NULL);
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCLOckTimer::OnStart() 
{
	m_bstop.EnableWindow(TRUE);
	m_bstart.EnableWindow(FALSE);
	GetDlgItem(IDC_EDMSTART)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDMSTOP)->EnableWindow(TRUE);
	GetDlgItem(IDC_EDMINTERVAL)->EnableWindow(FALSE);	

	m_edmstart = m_edtime1;
	m_vmanual = "yes";
	m_edminterval = 0;
	time( &start );
	// TODO: Add your control notification handler code here
	
}

void CCLOckTimer::OnStop() 
{
	m_bstop.EnableWindow(FALSE);
	m_bstart.EnableWindow(TRUE);

	GetDlgItem(IDC_EDMSTART)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDMSTOP)->EnableWindow(FALSE);
	GetDlgItem(IDC_EDMINTERVAL)->EnableWindow(TRUE);	

	m_vmanual = "no";
	m_edmstop = m_edtime1;

	time( &finish );
	m_edminterval = difftime( finish, start );
	// TODO: Add your control notification handler code here
	
}

void CCLOckTimer::OnDestroy() 
{
	CDialog::OnDestroy();
	KillTimer(m_uTimerID);
	// TODO: Add your message handler code here
	
}

void CCLOckTimer::OnTimer(UINT nIDEvent) 
{
	CHAR sz0[40], sz1[10];
	tm *vtm;
	time_t vtime_t;

	time(&vtime_t);
	vtm = localtime(&vtime_t);
//**************************** Icon ********************************
	if ((vtm->tm_sec % 6) == 0)
		m_icon.SetIcon(m_hIcon1);
	if ((vtm->tm_sec % 6) == 1)
		m_icon.SetIcon(m_hIcon2);
	if ((vtm->tm_sec % 6) == 2)
		m_icon.SetIcon(m_hIcon3);
	if ((vtm->tm_sec % 6) == 3)
		m_icon.SetIcon(m_hIcon4);
	if ((vtm->tm_sec % 6) == 4)
		m_icon.SetIcon(m_hIcon5);
	if ((vtm->tm_sec % 6) == 5)
		m_icon.SetIcon(m_hIcon6);
//**************************** m_edtimeampm = sz1 *******************	
	if (vtm->tm_hour > 12)
		itoa(vtm->tm_hour - 12 , sz1, 10);
	else
		itoa(vtm->tm_hour, sz1, 10);

    strcat(sz1, " : ");
    itoa(vtm->tm_min, &sz1[strlen(sz1)], 10);
    strcat(sz1, " : ");
    itoa(vtm->tm_sec, &sz1[strlen(sz1)], 10);
	strcat(sz1, ":");
	if (vtm->tm_hour > 12)
		strcat(sz1, " PM");
	else
		strcat(sz1, " AM");

//****************************** m_edtime1 = sz0 ******************

    itoa(vtm->tm_hour, sz0, 10);
    strcat(sz0, " : ");
    itoa(vtm->tm_min, &sz0[strlen(sz0)], 10);
    strcat(sz0, " : ");
    itoa(vtm->tm_sec, &sz0[strlen(sz0)], 10);

	m_edtime1 = sz0;
//**************************** m_edmstop = sz0 ***********************
	if (m_vmanual == "yes")
	{
		m_edmstop = sz0;
		time( &finish );
		m_edminterval = difftime( finish, start );
	}

	UpdateData(FALSE);

//*******************************************************************

	// TODO: Add your message handler code here and/or call default
	
	CDialog::OnTimer(nIDEvent);
}



