// SettingInfo.cpp : Implementation of CSettingInfo
#include "stdafx.h"
#include "ModemDial.h"
#include "SettingInfo.h"

#include "SettingModem.h"

#include <initguid.h>
#include <windowsx.h>

/////////////////////////////////////////////////////////////////////////////
// CSettingInfo

static LPDIRECTPLAY3A		lpDirectPlay3A;
static LPDIRECTPLAYLOBBY2A	lpDirectPlayLobby2A;
static LPVOID				lpConnectionext = NULL;
CString strmodem;
CString strservice;

// prototypes	
BOOL FAR PASCAL EnumModemAddress(REFGUID lpguidDataType, DWORD dwDataSize,
							LPCVOID lpData, LPVOID lpContext);
BOOL FAR PASCAL DirectPlayEnumConnectionsCallback(LPCGUID lpguidSP,
						LPVOID lpConnection, DWORD dwConnectionSize,
						LPCDPNAME lpName, DWORD dwFlags, LPVOID lpContext);

//////////////////////////////////////////////////////////////////////
//OnInitDialog
LRESULT CSettingInfo::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{

	HRESULT					hr;
	lpDirectPlayLobby2A = NULL;

	// Create an IDirectPlayLobby2A interface
	hr = CreateDirectPlayLobbyInterface(&lpDirectPlayLobby2A);
	if (FAILED(hr))
		goto FAILURE;

	// Fill Modem, Available Modems
	FillModem(m_hWnd, lpDirectPlayLobby2A);
	{

	//Move the Modem & Service Provider Names Values at IDD_SETTINGINFO
	//Form TYPE ATL COM to IDD_MODEM_SETTING Form Type MFC. 	
	CSettingModem *dlgsetting = new CSettingModem;

	dlgsetting->m_staticmodem = strmodem;
	dlgsetting->m_staticservice = strservice;

	//Destroy ATL COM Class CSettingInfo
	lpDirectPlay3A = NULL;
	lpDirectPlayLobby2A = NULL;	
	EndDialog(IDD);

	//Call MFC Class CSettingModem
	dlgsetting->DoModal();
	}
FAILURE:
	if (lpDirectPlayLobby2A)
		lpDirectPlayLobby2A->Release();
  
	return 1;  // Let the system set the focus
}

// EnumModemAddress
BOOL FAR PASCAL EnumModemAddress(REFGUID lpguidDataType, DWORD dwDataSize,
							LPCVOID lpData, LPVOID lpContext)
{
	HWND	hWnd = (HWND) lpContext;
	LPSTR	lpszStr = (LPSTR) lpData;

	//Modem ...
	if (IsEqualGUID(lpguidDataType, DPAID_Modem))
	{
		// Loop Over all Strings in List
		while (lstrlen(lpszStr))
		{
			//Store Modem Name
			strmodem = (CString)lpszStr;
			SetDlgItemText(hWnd,IDC_STATICMODEM,strmodem);

			// skip to Next String
			lpszStr += lstrlen(lpszStr) + 1;
		}
	}

	return (TRUE);
}

//DirectPlayEnumConnectionsCallback
BOOL FAR PASCAL DirectPlayEnumConnectionsCallback(LPCGUID lpguidSP,
						LPVOID lpConnection, DWORD dwConnectionSize,
						LPCDPNAME lpName, DWORD dwFlags, LPVOID lpContext)
{

    HWND			hWnd = (HWND) lpContext;
//    LRESULT			iIndex;
	LPVOID			lpConnectionBuffer;


	//Store Special Service Provider Nmae 'Modem Connection, DPSPGUID_MODEM'
	if (IsEqualGUID(*lpguidSP, DPSPGUID_MODEM))
	{
		// Store Service Provider Name 
		SetDlgItemText(hWnd, IDC_STATICSERVICE,lpName->lpszShortNameA);
		strservice = (CString)lpName->lpszShortNameA;
		
	// make space for connection shortcut
	lpConnectionBuffer = GlobalAllocPtr(GHND, dwConnectionSize);
	if (lpConnectionBuffer == NULL)
		goto FAILURE;

	//Store Pointer 'lpConnection' to 'lpConnectionBuffer' between Buffers
	memcpy(lpConnectionBuffer, lpConnection, dwConnectionSize);

	//lpConnectionext Pointer Contains all Info about Connection,
	lpConnectionext = lpConnectionBuffer;
	}

FAILURE:

    return (TRUE);
}

// FillModem
HRESULT CSettingInfo::FillModem(HWND hWnd, LPDIRECTPLAYLOBBY2A lplpDirectPlayLobby2A)
{

	lpDirectPlay3A = NULL;

	HRESULT				hr;
	LPVOID				lpAddress = NULL;
	DWORD				dwAddressSize = 0;


	// Create an IDirectPlay3A interface
	hr = CreateDirectPlayInterface(&lpDirectPlay3A);
	if (FAILED(hr))
		goto FAILURE;

	
	// put all the available connections 
	hr = lpDirectPlay3A->EnumConnections(&LIBID_ModemDialLib, DirectPlayEnumConnectionsCallback, hWnd,0);
	if (FAILED(hr))
		goto FAILURE;


	//Initializes a DirectPlay Modem connection. 
	hr = lpDirectPlay3A->InitializeConnection(lpConnectionext,0);
	
	//Get Size of Player Address for Player Zero
	hr = lpDirectPlay3A->GetPlayerAddress( DPID_ALLPLAYERS, NULL, &dwAddressSize);
	if (hr != DPERR_BUFFERTOOSMALL)
		goto FAILURE;

	// Make Room for it
	lpAddress = GlobalAllocPtr(GHND, dwAddressSize);
	if (lpAddress == NULL)
	{
		hr = DPERR_NOMEMORY;
		goto FAILURE;
	}

	// Get the Address
	hr = lpDirectPlay3A->GetPlayerAddress( DPID_ALLPLAYERS, lpAddress, &dwAddressSize);
   if (FAILED(hr))
		goto FAILURE;

	// Get Modem Name Strings 
	hr = lplpDirectPlayLobby2A->EnumAddress( EnumModemAddress, 
				         			 lpAddress, dwAddressSize, hWnd);
    if (FAILED(hr))
		goto FAILURE;


FAILURE:
	if (lpDirectPlay3A)
		lpDirectPlay3A->Release();
	if (lpAddress)
		GlobalFreePtr(lpAddress);

	return (hr);
}

//CreateDirectPlayInterface
HRESULT CSettingInfo::CreateDirectPlayInterface( LPDIRECTPLAY3A *lplpDirectPlay3A )
{
	HRESULT				hr;
	LPDIRECTPLAY3A		lpDirectPlay3A = NULL;
		
	//Create an IDirectPlay3A interface
	hr = CoCreateInstance(	CLSID_DirectPlay, NULL, CLSCTX_INPROC_SERVER, 
		IID_IDirectPlay3A, (LPVOID*)&lpDirectPlay3A);

	//Return Interface Created
	*lplpDirectPlay3A = lpDirectPlay3A;

	return (hr);
}

//CreateDirectPlayInterface
HRESULT CSettingInfo::CreateDirectPlayLobbyInterface( LPDIRECTPLAYLOBBY2A	*lplpDirectPlayLobby2A ) 
{
	HRESULT				hr;
	LPDIRECTPLAYLOBBY2A	lpDirectPlayLobby2A = NULL;

	//Create an IDirectPlayLobby2A interface	
	hr = CoCreateInstance( CLSID_DirectPlayLobby, NULL, CLSCTX_INPROC_SERVER, 
	        	IID_IDirectPlayLobby2A, (LPVOID*)&lpDirectPlayLobby2A);

	//Return Interface Created
	*lplpDirectPlayLobby2A = lpDirectPlayLobby2A;

	return (hr);
}


